package com.sample;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.impl.EnvironmentFactory;
import org.drools.io.ResourceFactory;
import org.drools.persistence.jpa.JPAKnowledgeService;
import org.drools.runtime.Environment;
import org.drools.runtime.EnvironmentName;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.junit.Test;

import bitronix.tm.TransactionManagerServices;
import bitronix.tm.resource.jdbc.PoolingDataSource;

public class ProcessMain {

	private static PoolingDataSource ds = new PoolingDataSource();

	private static void dataSource() {
		// ds.setUniqueName("jdbc/jbpm-ds");
		// ds.setClassName("org.h2.jdbcx.JdbcDataSource");
		// ds.setMaxPoolSize(3);
		// ds.setAllowLocalTransactions(true);
		// ds.getDriverProperties().put("user", "sa");
		// ds.getDriverProperties().put("password", "sasa");
		// ds.getDriverProperties().put("URL", "jdbc:h2:mem:mydb");
		// ds.init();

		ds.setUniqueName("jdbc/jbpm-ds");
		ds.setClassName("com.mysql.jdbc.jdbc2.optional.MysqlXADataSource");
		ds.setMaxPoolSize(3);
		ds.setAllowLocalTransactions(true);
		ds.getDriverProperties().put("user", "root");
		ds.getDriverProperties().put("password", "manav");
		ds.getDriverProperties().put("Url", "jdbc:mysql://localhost:3306/jbpm_db");
		// ds.getDriverProperties().put("driverClassName", "org.h2.Driver");
		ds.init();
	}

	@Test
	public void testCreateProcess() {

		dataSource();

		Environment env = EnvironmentFactory.newEnvironment();
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("org.jbpm.persistence.jpa");
		env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, emf);
		env.set(EnvironmentName.TRANSACTION_MANAGER, TransactionManagerServices.getTransactionManager());
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();

		kbuilder.add(ResourceFactory.newClassPathResource("sampleProcess.bpmn"), ResourceType.BPMN2);

		KnowledgeBase kbase = kbuilder.newKnowledgeBase();

		StatefulKnowledgeSession ksession = JPAKnowledgeService.newStatefulKnowledgeSession(kbase, null, env);

		System.out.println(">>> Session id : " + ksession.getId());

		MockAsyncHTWorkItemHandler mockSyncHTWorkItemHandler = new MockAsyncHTWorkItemHandler();
		MockExternalServiceWorkItemHandler mockExternalServiceWorkItemHandler = new MockExternalServiceWorkItemHandler();
		ksession.getWorkItemManager().registerWorkItemHandler("Human Task", mockSyncHTWorkItemHandler);
		// ksession.getWorkItemManager().registerWorkItemHandler("External
		// Service Call",
		// mockExternalServiceWorkItemHandler);

		System.out.println(">>> Start process instance");
		ProcessInstance processInstance = ksession.startProcess("sampleProcess");

		System.out.println(">>> process id :-" + processInstance.getId());

		try {
			Thread.sleep(5000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println(">>> Completing the first Human Interaction");
		ksession.getWorkItemManager().completeWorkItem(mockSyncHTWorkItemHandler.getId(), null);

		try {
			Thread.sleep(5000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println(">>> Completing the first Human Interaction");
		ksession.getWorkItemManager().completeWorkItem(mockSyncHTWorkItemHandler.getId(), null);

	}


	@Test
	public void testResumeProcess() {
		dataSource();

		Environment env = EnvironmentFactory.newEnvironment();
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("org.jbpm.persistence.jpa");
		env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, emf);
		env.set(EnvironmentName.TRANSACTION_MANAGER, TransactionManagerServices.getTransactionManager());
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();

		kbuilder.add(ResourceFactory.newClassPathResource("sampleProcess.bpmn"), ResourceType.BPMN2);

		KnowledgeBase kbase = kbuilder.newKnowledgeBase();

		StatefulKnowledgeSession ksession = JPAKnowledgeService.loadStatefulKnowledgeSession(3, kbase, null, env);

		ProcessInstance processInstance = ksession.getProcessInstance(4);
		System.out.println(">>>  Process state : " + processInstance.getState());
		ksession.startProcess(processInstance.getProcessId());

	}

}